/* Create user management and admin tables for use by authenticating
 * web front end interface.
 */

create table users (
	user_name varchar(32),
	user_pass varchar(32),
	user_role char
);

/* Assure database always has only one instance of unique user
 * identifier.
 */

create unique index users_hash on users using btree(username);

create table modules (
	module_name varchar(32),
	module_permit char
);

create unique index module_hash on modules using btree(module_name);

create table enrollment (
	user_name varchar(32),
	module_name varchar(32),
	user_permit char
);

create unique index enrollment_hash on enrollment(module_name, user_name);

/* Work out permissions */

revoke select on users, modules, enrollment from public;

