// Copyright (C) 2000 Open Source Telecom Corporation.
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "database.h"

class CDRLogger : protected CDRDriver
{
public:
	CDRLogger();

	void Commit(char *fields[18]);

} cdrlogger;

CDRLogger::CDRLogger() : 
CDRDriver()
{
	if(initdb)
		database->Exec("cdr");
}

void CDRLogger::Commit(char *fields[18])
{
	typedef struct
	{
		char *name;
		bool quote;
	}	field_t;

	static field_t defs[] = {
		{"callid", true},
		{"calltype", true},
		{"localization", true},
		{"node", true},
		{"port", true},
		{"policy", true},
		{"dialed", true},
		{"origin", true},
		{"target", true},
		{"account", true},
		{"date", true},
		{"time", true},
		{"duration", false},
		{"location", true},
		{"cost", false},
		{"sessionid",true},
		{"infodigits", true},
		{NULL, false}};

	char query[1024];
	strstream q(query, 1024);
	int f = 0;
	
	query[0] = 0;
	q << "insert into calls values(";

	while(defs[f].name)
	{
		if(f)
			q << ",";
		if(defs[f].quote)
			q << "\'" << fields[f] << "\'";
		else
			q << fields[f];
		++f;
	}
	
	q << ",false);" << ends;
	database->Query(query);
}














